<!DOCTYPE html><html lang="en"><head><meta charSet="utf-8"/><meta http-equiv="X-UA-Compatible" content="IE=edge"/><title>Overview · Merge</title><meta name="viewport" content="width=device-width"/><meta name="generator" content="Docusaurus"/><meta name="description" content="&lt;p&gt;This set of documents is a one stop shop exhaustive reference for installing and administering a Merge portal instance.&lt;/p&gt;
"/><meta name="docsearch:language" content="en"/><meta property="og:title" content="Overview · Merge"/><meta property="og:type" content="website"/><meta property="og:url" content="https://mergetb.gitlab.io/index.html"/><meta property="og:description" content="&lt;p&gt;This set of documents is a one stop shop exhaustive reference for installing and administering a Merge portal instance.&lt;/p&gt;
"/><meta property="og:image" content="https://mergetb.gitlab.io/img/logo.png"/><meta name="twitter:card" content="summary"/><meta name="twitter:image" content="https://mergetb.gitlab.io/img/logo.png"/><link rel="shortcut icon" href="/img/merge.png"/><link rel="stylesheet" href="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/styles/dracula.min.css"/><link rel="alternate" type="application/atom+xml" href="https://mergetb.gitlab.io/blog/atom.xml" title="Merge Blog ATOM Feed"/><link rel="alternate" type="application/rss+xml" href="https://mergetb.gitlab.io/blog/feed.xml" title="Merge Blog RSS Feed"/><script type="text/javascript" src="https://buttons.github.io/buttons.js"></script><link rel="stylesheet" href="/css/main.css"/></head><body class="sideNavVisible separateOnPageNav"><div class="fixedHeaderContainer"><div class="headerWrapper wrapper"><header><a href="/"><img class="logo" src="/img/merge-light.svg" alt="Merge"/><h2 class="headerTitleWithLogo">Merge</h2></a><div class="navigationWrapper navigationSlider"><nav class="slidingNav"><ul class="nav-site nav-site-internal"><li class=""><a href="/docs/hello-world.html" target="_self">Experimentation</a></li><li class=""><a href="/docs/site-basics.html" target="_self">Site Hosting</a></li><li class="siteNavGroupActive siteNavItemActive"><a href="/docs/portal-admin.html" target="_self">Portal Hosting</a></li><li class=""><a href="/docs/tech.html" target="_self">Technology</a></li><li class=""><a href="/blog/" target="_self">News</a></li></ul></nav></div></header></div></div><div class="navPusher"><div class="docMainWrapper wrapper"><div class="container docsNavContainer" id="docsNav"><nav class="toc"><div class="toggleNav"><section class="navWrapper wrapper"><div class="navBreadcrumb wrapper"><div class="navToggle" id="navToggler"><i></i></div><h2><i>›</i><span>Installation</span></h2><div class="tocToggler" id="tocToggler"><i class="icon-toc"></i></div></div><div class="navGroups"><div class="navGroup"><h3 class="navGroupCategoryTitle">Installation</h3><ul><li class="navListItem navListItemActive"><a class="navItem" href="/docs/portal-admin.html">Overview</a></li><li class="navListItem"><a class="navItem" href="/docs/install.html">Portal Installation</a></li></ul></div><div class="navGroup"><h3 class="navGroupCategoryTitle">Administration</h3><ul><li class="navListItem"><a class="navItem" href="/docs/net-admin.html">Networks</a></li><li class="navListItem"><a class="navItem" href="/docs/service-admin.html">Core Services</a></li><li class="navListItem"><a class="navItem" href="/docs/db-admin.html">Databases</a></li><li class="navListItem"><a class="navItem" href="/docs/proxy-admin.html">Proxy</a></li><li class="navListItem"><a class="navItem" href="/docs/user-admin.html">Users, Pools &amp; Projects</a></li><li class="navListItem"><a class="navItem" href="/docs/logs.html">Logs</a></li></ul></div></div></section></div><script>
            document.addEventListener('DOMContentLoaded', function() {
              createToggler('#navToggler', '#docsNav', 'docsSliderActive');
              createToggler('#tocToggler', 'body', 'tocActive');

              const headings = document.querySelector('.toc-headings');
              headings && headings.addEventListener('click', function(event) {
                if (event.target.tagName === 'A') {
                  document.body.classList.remove('tocActive');
                }
              }, false);

              function createToggler(togglerSelector, targetSelector, className) {
                var toggler = document.querySelector(togglerSelector);
                var target = document.querySelector(targetSelector);

                if (!toggler) {
                  return;
                }

                toggler.onclick = function(event) {
                  event.preventDefault();

                  target.classList.toggle(className);
                };
              }
            });
        </script></nav></div><div class="container mainContainer"><div class="wrapper"><div class="post"><header class="postHeader"><h1 class="postHeaderTitle">Overview</h1></header><article><div><span><p>This set of documents is a one stop shop exhaustive reference for installing and administering a Merge portal instance.</p>
<h2><a class="anchor" aria-hidden="true" id="core-components"></a><a href="#core-components" aria-hidden="true" class="hash-link"><svg class="hash-link-icon" aria-hidden="true" height="16" version="1.1" viewBox="0 0 16 16" width="16"><path fill-rule="evenodd" d="M4 9h1v1H4c-1.5 0-3-1.69-3-3.5S2.55 3 4 3h4c1.45 0 3 1.69 3 3.5 0 1.41-.91 2.72-2 3.25V8.59c.58-.45 1-1.27 1-2.09C10 5.22 8.98 4 8 4H4c-.98 0-2 1.22-2 2.5S3 9 4 9zm9-3h-1v1h1c1 0 2 1.22 2 2.5S13.98 12 13 12H9c-.98 0-2-1.22-2-2.5 0-.83.42-1.64 1-2.09V6.25c-1.09.53-2 1.84-2 3.25C6 11.31 7.55 13 9 13h4c1.45 0 3-1.69 3-3.5S14.5 6 13 6z"></path></svg></a>Core Components</h2>
<p>A Merge portal instance is a collection of services, databases, proxies, file systems, and a network gateway. In concept these components could be configured and deployed in a variety of ways. This guide presents exactly one way to configure and deploy a portal that maximizes stability, fault tolerance and maintainability. We call this configuration and deployment strategy the <em>reference deployment</em>. A diagram of the reference deployment is depicted below.</p>
<p><img src="/img/merge-arch.png" alt="merge-arch"></p>
<h3><a class="anchor" aria-hidden="true" id="services"></a><a href="#services" aria-hidden="true" class="hash-link"><svg class="hash-link-icon" aria-hidden="true" height="16" version="1.1" viewBox="0 0 16 16" width="16"><path fill-rule="evenodd" d="M4 9h1v1H4c-1.5 0-3-1.69-3-3.5S2.55 3 4 3h4c1.45 0 3 1.69 3 3.5 0 1.41-.91 2.72-2 3.25V8.59c.58-.45 1-1.27 1-2.09C10 5.22 8.98 4 8 4H4c-.98 0-2 1.22-2 2.5S3 9 4 9zm9-3h-1v1h1c1 0 2 1.22 2 2.5S13.98 12 13 12H9c-.98 0-2-1.22-2-2.5 0-.83.42-1.64 1-2.09V6.25c-1.09.53-2 1.84-2 3.25C6 11.31 7.55 13 9 13h4c1.45 0 3-1.69 3-3.5S14.5 6 13 6z"></path></svg></a>Services</h3>
<p>All Merge services are managed and orchestrated by a <a href="https://kubernetes.io">Kubernetes</a> instance deployed within the portal. The Merge Kubernetes instance is a <a href="https://kubernetes.io/docs/admin/high-availability/">high-availability</a> instance, meaning that if any one hardware component of the system goes down or is separated from the network, the remaining components can continue to function and the lost failed component can be recovered.</p>
<p>NOTE: Every major Merge subsystem is designed in a redundant fault-tolerant way.</p>
<p>There are 7 core services in the Merge portal.</p>
<ul>
<li><p><strong>API:</strong> An HTTPS-only REST implementation of the Merge experimentation and resource provider APIs. The API component implements the REST and HTTPS parts of the API but passes requests along to other core services for handling.</p></li>
<li><p><strong>workspace:</strong> The workspace service is responsible for managing users and projects.</p></li>
<li><p><strong>discover:</strong> The discover service implements the Merge discovery API. This API takes experiment topologies as input and returns the resources that are currently available to realize them.</p></li>
<li><p><strong>realize:</strong> The realize service maps abstract constraint-based experiments onto concrete resources as reservations. It makes no attempt to configure or provision the resources - that is the job of the materializer. The sole purpose of the realize service is to compute the embedding of a user's <em>experiment network</em> onto the <em>resource network</em> (a very computationally intensive problem), and make the associated reservations.</p></li>
<li><p><strong>materialize:</strong> The materialize service takes a realization as input, provisioning and configuring the associated resources. Resources are not located in the portal, they are located at sites. Each site has a site <em>commander</em> that is in charge of a number of device drivers that ultimately control devices. The materialization agents that run in the portal engage in a well defined protocol with site commanders to achieve materialization.</p></li>
<li><p><strong>commission:</strong> Resource providers add and remove resources from a Merge network through commissioning and decommissioning respectively. The commission service is responsible for maintaining global resource state as it evolves through the commission/decommission lifecycle.</p></li>
<li><p><strong>alloc:</strong> Unlike the other 6 service components, the alloc service is strictly an internal service. It presents an API to all of the other services that perform resource allocation and deallocation that decouple them from the resource database.</p></li>
</ul>
</span></div></article></div><div class="docs-prevnext"><a class="docs-next button" href="/docs/install.html"><span>Portal Installation</span><span class="arrow-next"> →</span></a></div></div></div><nav class="onPageNav"><ul class="toc-headings"><li><a href="#core-components">Core Components</a><ul class="toc-headings"><li><a href="#services">Services</a></li></ul></li></ul></nav></div><footer class="nav-footer" id="footer"><section class="sitemap"><a href="/" class="nav-home"><img src="/img/merge-light.svg" alt="Merge" width="66" height="58"/></a><div><h5>Docs</h5><a href="/docs/en/hello-world.html">Experimentation</a><a href="/docs/en/site-basics.html">Site Hosting</a><a href="/docs/en/portal-admin.html">Portal Hosting</a></div><div><h5>Community</h5><a href="/en/users.html">User Showcase</a><a href="https://mergetb.slack.com/">Project Chat</a></div><div><h5>More</h5><a href="/blog">Blog</a><a href="https://gitlab.com/mergetb">GitLab</a></div></section><section class="copyright">Copyright © 2018 Information Sciences Institute</section></footer></div></body></html>